## ocamlnet 4.1.2

=== Makefile ===
# make all: compiles the configured packages with ocamlc
# make opt: compiles the configured packages with ocamlopt
# make install: installs the configured packages
# make clean: cleans everything up

# Inclusion of Makefile.conf may fail when cleaning up:
-include Makefile.conf

NAME=ocamlnet
TOP_DIR=.

# PKGLIST: should be set in Makefile.conf. It contains the packages to
# compile and to install. The following assignment sets it to its 
# default value if no Makefile.conf exists.
PKGLIST ?= netstring cgi

.PHONY: build
build: all
	if ocamlopt 2>/dev/null; then $(MAKE) opt; fi

.PHONY: all
all: tools
	for pkg in $(PKGLIST); do \
		( cd src/$$pkg && $(MAKE) -f Makefile.pre generate ) || exit; \
		( cd src/$$pkg && $(MAKE) -f Makefile.pre depend ) || exit; \
		( cd src/$$pkg && $(MAKE) all ) || exit; \
	done

.PHONY: opt
opt: tools
	for pkg in $(PKGLIST); do \
		( cd src/$$pkg && $(MAKE) -f Makefile.pre generate ) || exit; \
		( cd src/$$pkg && $(MAKE) -f Makefile.pre depend ) || exit; \
		( cd src/$$pkg && $(MAKE) opt ) || exit; \
	done


.PHONY: doc
doc:
	for pkg in src/*/.; do \
	    test ! -f $$pkg/Makefile -o -f $$pkg/doc-ignore || \
		{ ( cd $$pkg && $(MAKE) -f Makefile.pre generate ) || exit; \
		  ( cd $$pkg && $(MAKE) -f Makefile.pre depend ) || exit; \
		  ( cd $$pkg && $(MAKE) doc-dump ) || exit; \
		}; \
	done
	cd doc; $(MAKE) doc

.PHONY: tools
tools:
	( cd tools/cppo-$(CPPO_VERSION) && $(MAKE) all )
	( cd tools/unimap_to_ocaml && $(MAKE) all )


# The following PHONY rule is important for Cygwin:
.PHONY: install
install:
	for pkg in $(PKGLIST); do \
		( cd src/$$pkg && $(MAKE) -f Makefile.pre install ) || exit; \
	done

.PHONY: uninstall
uninstall:
	for pkg in src/*/.; do \
		test ! -f $$pkg/Makefile || \
			( cd $$pkg && $(MAKE) -f Makefile.pre uninstall); \
	done

.PHONY: clean
clean:
	for pkg in src/*/.; do \
		test ! -f $$pkg/Makefile || \
			( cd $$pkg && $(MAKE) -f Makefile.pre clean); \
	done
	if test -f doc/Makefile; then cd doc && $(MAKE) clean; fi
	( cd tools/cppo-$(CPPO_VERSION) && $(MAKE) clean )
	( cd tools/unimap_to_ocaml && $(MAKE) clean )

.PHONY: clean-doc
clean-doc:
	for pkg in src/*/.; do \
		test ! -f $$pkg/Makefile -o -f $$pkg/doc-ignore || \
			( cd $$pkg && $(MAKE) -f Makefile.pre clean-doc); \
	done
	cd doc && $(MAKE) clean-doc

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean:
	rm -f Makefile.conf 
	rm -rf tmp
	for pkg in src/*/.; do \
		test ! -f $$pkg/Makefile || \
			( cd $$pkg && $(MAKE) -f Makefile.pre distclean); \
	done

# That one is for oasis

.PHONY: postconf
postconf:
	cat setup.save >>setup.data


# phony because VERSION may also change
.PHONY: _oasis
_oasis: _oasis.in
	v=`./configure -version`; sed -e 's/@VERSION@/'"$$v/" _oasis.in >_oasis
	oasis setup

=== examples/nethttpd/Makefile ===
all: easy_daemon easy_reactor easy_engine proxy_engine file_reactor \
     file_mt_reactor file_engine netplex netplex_auth netplex_tls

easy_daemon: easy_daemon.ml
	ocamlfind ocamlc -o easy_daemon -package "netstring,unix,nethttpd,netcgi2" \
		easy_daemon.ml -linkpkg -g

easy_reactor: easy_reactor.ml
	ocamlfind ocamlc -o easy_reactor -package "netstring,unix,nethttpd,netcgi2" \
		easy_reactor.ml -linkpkg -g

easy_engine: easy_engine.ml
	ocamlfind ocamlc -o easy_engine -package "netstring,unix,equeue,nethttpd,netcgi2" \
		easy_engine.ml -linkpkg -g

easy_engine.opt: easy_engine.ml
	ocamlfind ocamlopt -o easy_engine.opt -package "netstring,unix,equeue,nethttpd,netcgi2" \
		easy_engine.ml -linkpkg

proxy_engine: proxy_engine.ml
	ocamlfind ocamlc -o proxy_engine -package "netstring,unix,equeue,nethttpd,netcgi2" \
		proxy_engine.ml -linkpkg -g

proxy_engine.opt: proxy_engine.ml
	ocamlfind ocamlopt -o proxy_engine.opt -package "netstring,unix,equeue,nethttpd,netcgi2" \
		proxy_engine.ml -linkpkg 

file_reactor: file_reactor.ml
	ocamlfind ocamlc -o file_reactor -package "netstring,unix,nethttpd,netcgi2" \
		file_reactor.ml -linkpkg -g

file_mt_reactor: file_mt_reactor.ml
	ocamlfind ocamlc -o file_mt_reactor -package "netstring,unix,threads,nethttpd,netcgi2" \
		file_mt_reactor.ml -linkpkg -g -thread

file_mt_reactor.opt: file_mt_reactor.ml
	ocamlfind ocamlopt -o file_mt_reactor.opt -package "netstring,unix,threads,nethttpd,netcgi2" \
		file_mt_reactor.ml -linkpkg -thread

file_engine: file_engine.ml
	ocamlfind ocamlc -o file_engine -package "netstring,unix,equeue,nethttpd,netcgi2" \
		file_engine.ml -linkpkg -g

netplex: netplex.ml
	ocamlfind ocamlc -o netplex -package "netstring,netcgi2,unix,nethttpd,netplex" \
		-thread netplex.ml -linkpkg -g
netplex_auth: netplex_auth.ml
	ocamlfind ocamlc -o netplex_auth -package "netstring,netcgi2,unix,nethttpd,netplex" \
		-thread netplex_auth.ml -linkpkg -g
netplex_tls: enable_tls.ml netplex.ml
	ocamlfind ocamlc -o netplex_tls -package "netstring,netcgi2,unix,nethttpd,netplex,nettls-gnutls" \
		-thread enable_tls.ml netplex.ml -linkpkg -g -custom

clean:
	rm -f *.cmi *.cmo *.cmx *.o
	rm -f test_acceptor easy_daemon easy_reactor easy_engine easy_engine.opt
	rm -f proxy_engine proxy_engine.opt file_reactor file_mt_reactor 
	rm -f file_mt_reactor.opt file_engine netplex netplex_auth netplex_tls

=== src/netgss-system/Makefile ===
TOP_DIR=../..

include $(TOP_DIR)/Makefile.conf
# include Makefile.conf

PKGNAME  = netgss-system
OBJECTS  = netgss_bindings.cmo netgss_util.cmo netgss.cmo
COBJECTS = netgss_bindings_stubs.o
DOBJECTS = netgss_bindings.mli netgss.mli

LINK_OPTIONS = $(NETGSS_LINK_OPTIONS)
#LINK_OPTIONS = -lkrb5

CC_OPTIONS = $(NETGSS_CFLAGS)
CC_OPTIONS_FOR_netgss_bindings_stubs.c = -ccopt -Wno-unused-function \
    -ccopt -DNETGSS_VARIANT_"$(NETGSS_VARIANT)"

INCLUDES = $(INC_NETSYS) $(INC_NETSTRING)

OCAMLC_OPTIONS += $(STRING_OPTS)
OCAMLOPT_OPTIONS += $(STRING_OPTS)

PP_OPTIONS = -pp "$(CPPO) $(PP_BYTES) $(PP_DEPRECATED)"

DOC_IGNORABLE = true

include $(TOP_DIR)/Makefile.rules

.PHONY: cobjects
cobjects: $(COBJECTS)

netgss_bindings.ml: done_reconfigure
	@:

netgss_bindings.mli: done_reconfigure
	@:

netgss_bindings_stubs.c: done_reconfigure
	@:

done_reconfigure: gssapi.descr gssapi.c gssapi.ml gssapi.mli
	./reconfigure

include depend

=== src/nethttpd/Makefile ===
TOP_DIR=../..

include $(TOP_DIR)/Makefile.conf

PKGNAME  = nethttpd
OBJECTS  = nethttpd_types.cmo nethttpd_util.cmo \
           nethttpd_kernel.cmo nethttpd_reactor.cmo \
	  nethttpd_engine.cmo nethttpd_services.cmo nethttpd_plex.cmo

DOBJECTS = nethttpd_types.mli nethttpd_kernel.mli nethttpd_reactor.mli \
	   nethttpd_engine.mli nethttpd_services.mli nethttpd_plex.mli \
	   nethttpd_util.mli nethttpd_intro.txt

INCLUDES += $(INC_EQUEUE) $(INC_NETSTRING) $(INC_NETCGI2) $(INC_NETPLEX) \
            $(INC_NETSYS)

OCAMLC_OPTIONS += $(STRING_OPTS)
OCAMLOPT_OPTIONS += $(STRING_OPTS)

PP_OPTIONS = -pp "$(CPPO) $(PP_BYTES) $(PP_DEPRECATED)"
DOC_IGNORABLE = true

include $(TOP_DIR)/Makefile.rules

include depend

=== src/netmulticore/Makefile ===
TOP_DIR=../..

include $(TOP_DIR)/Makefile.conf

PKGNAME  = netmulticore
OBJECTS  = netmcore.cmo netmcore_camlbox.cmo netmcore_util.cmo \
	   netmcore_mempool.cmo netmcore_heap.cmo netmcore_ref.cmo \
	   netmcore_array.cmo netmcore_sem.cmo netmcore_mutex.cmo \
	   netmcore_condition.cmo netmcore_queue.cmo netmcore_buffer.cmo \
	   netmcore_matrix.cmo netmcore_hashtbl.cmo netmcore_process.cmo
DOBJECTS = netmcore.mli netmcore_camlbox.mli netmcore_mempool.mli \
	   netmcore_heap.mli netmcore_ref.mli netmcore_array.mli \
	   netmcore_sem.mli netmcore_mutex.mli netmcore_condition.mli \
	   netmcore_queue.mli netmcore_buffer.mli netmcore_matrix.mli \
	   netmcore_hashtbl.mli netmcore_process.mli \
	   netmcore_tut.txt netmcore_basics.txt

INCLUDES += $(INC_EQUEUE) $(INC_RPC) $(INC_NETSTRING) $(INC_NETSYS) \
            $(INC_NETPLEX) $(INC_NETCAMLBOX)

OCAMLC_OPTIONS += $(STRING_OPTS)
OCAMLOPT_OPTIONS += $(STRING_OPTS)

PP_OPTIONS = -pp "$(CPPO) $(PP_BYTES) $(PP_DEPRECATED)"

DOC_IGNORABLE = true

include $(TOP_DIR)/Makefile.rules

t_toploop: t_toploop.ml $(PKGNAME).cma
	OCAMLPATH=.. \
	ocamlfind ocamlc -g -o t_toploop \
	   toplevellib.cma $(PKGNAME).cma t_toploop.ml \
	   -package "equeue,rpc,netstring,netsys,netplex,netcamlbox" \
	   -linkpkg -linkall

t_mempool: t_mempool.ml $(PKGNAME).cma
	OCAMLPATH=.. \
	ocamlfind ocamlc -g -o t_mempool \
	   $(PKGNAME).cma t_mempool.ml \
	   -package "equeue,rpc,netstring,netsys,netplex,netcamlbox" \
	   -linkpkg



include depend

=== src/netstring/Makefile ===
TOP_DIR=../..

include $(TOP_DIR)/Makefile.conf

OBJECTS  = netconst.cmo netstring_str.cmo netbuffer.cmo netunichar.cmo \
	   netaux.cmo netstring_tstring.cmo \
           netchannels.cmo netchannels_crypto.cmo netsockaddr.cmo \
	   netdb.cmo netmappings_asn1.cmo netmappings.cmo netconversion.cmo \
           netulex.cmo netencoding.cmo netstream.cmo netdate.cmo \
	   netmime_string.cmo \
           nethtml_scanner.cmo nethtml.cmo \
	   neturl.cmo neturl_ldap.cmo netsaslprep_data.cmo netsaslprep.cmo \
	   netaddress.cmo netcompression.cmo \
	   netmime.cmo netmime_header.cmo netmime_channels.cmo \
	   netsendmail.cmo nethttp.cmo \
	   netpagebuffer.cmo netfs.cmo netglob_lex.cmo netglob.cmo \
	   netauth.cmo netnumber.cmo netxdr_mstring.cmo netxdr.cmo \
	   netasn1.cmo netasn1_encode.cmo netoid.cmo netdn.cmo netx509.cmo \
           netascii_armor.cmo netx509_pubkey.cmo netx509_pubkey_crypto.cmo \
	   nettls_support.cmo \
	   netgssapi_support.cmo netgssapi_auth.cmo \
	   netmech_scram.cmo netmech_scram_gssapi.cmo netmech_scram_sasl.cmo \
	   netmech_scram_http.cmo \
	   netmech_plain_sasl.cmo netmech_crammd5_sasl.cmo \
	   netmech_digest.cmo netmech_digest_sasl.cmo \
	   netmech_digest_http.cmo netmech_gs2_sasl.cmo netmech_krb5_sasl.cmo \
	   netmech_spnego_http.cmo

PKGNAME  = netstring

REQUIRES += $(REGEXP_PROVIDER_MAKE) bigarray
INCLUDES += $(INC_NETSYS)
INCLUDES += -I ../netstring-pcre

INSTALL_EXTRA_CMO = netstring_top \
		    netaccel_link
INSTALL_EXTRA_CMX = netconversion \
		    netbuffer netnumber netxdr
INSTALL_EXTRA = $(INSTALL_EXTRA_CMO:=.cmo) \
		$(INSTALL_EXTRA_CMX:=.cmx) $(INSTALL_EXTRA_CMX:=.p.cmx) \
		$(INSTALL_EXTRA_CMX:=.o) $(INSTALL_EXTRA_CMX:=.p.o) \
		dllnetaccel_c.*

DOBJECTS = netconversion.mli netchannels.mli netstream.mli netmime_string.mli \
	netmime.mli netsendmail.mli neturl.mli netaddress.mli netbuffer.mli \
	netmime_header.mli netmime_channels.mli neturl_ldap.mli \
	netdate.mli netencoding.mli netulex.mli netaccel.mli \
	netaccel_link.mli nethtml.mli netstring_str.mli \
	netmappings.mli netaux.mli nethttp.mli netpagebuffer.mli \
	netfs.mli netglob.mli netauth.mli netsockaddr.mli \
        netnumber.mli netxdr_mstring.mli netxdr.mli \
	netcompression.mli netunichar.mli netasn1.mli netasn1_encode.mli \
	netoid.mli netstring_tstring.mli \
	netdn.mli netx509.mli netascii_armor.mli nettls_support.mli \
	netmech_scram.mli netmech_scram_gssapi.mli netmech_scram_sasl.mli \
        netmech_scram_http.mli \
	netgssapi_support.mli netgssapi_auth.mli netchannels_crypto.mli \
	netx509_pubkey.mli netx509_pubkey_crypto.mli netsaslprep.mli \
	netmech_plain_sasl.mli netmech_crammd5_sasl.mli \
	netmech_digest_sasl.mli netmech_digest_http.mli \
	netmech_krb5_sasl.mli netmech_gs2_sasl.mli netmech_spnego_http.mli \
	netchannels_tut.txt netmime_tut.txt netsendmail_tut.txt \
	netulex_tut.txt neturl_tut.txt

OCAMLC_OPTIONS += $(STRING_OPTS)
OCAMLOPT_OPTIONS += $(STRING_OPTS)

PP_OPTIONS = -pp "$(CPPO) $(NETNUMBER_DEFS) $(REGEXP_DEFS) $(PP_BYTES) $(PP_DEPRECATED)"

ALL_EXTRA = netaccel.cma netaccel_link.cmo netstring_top.cmo

netaccel.cma: netaccel_c.o netaccel.cmo
	$(OCAMLMKLIB) -o netaccel -oc netaccel_c netaccel_c.o netaccel.cmo

NETNUMBER_DEFS = -D WORDSIZE_$(WORD_SIZE) -D HOST_IS_$(ENDIANESS) \
                 -D USE_NETSYS_XDR

OCAMLOPT_OPTIONS_FOR_netbuffer.ml = -inline 10
OCAMLOPT_OPTIONS_FOR_netnumber.ml = -inline 10
OCAMLOPT_OPTIONS_FOR_xdr.ml = -inline 5
OCAMLC_OPTIONS_FOR_netstring_top.ml = -I +compiler-libs

include $(TOP_DIR)/Makefile.rules

distclean::
	$(MAKE) clean

include depend

=== src/netsys/Makefile ===
TOP_DIR=../..

include $(TOP_DIR)/Makefile.conf
include Makefile.conf

PKGNAME  = netsys
OBJECTS  = netsys_conf.cmo netsys_types.cmo \
           netlog.cmo netexn.cmo netsys_impl_util.cmo netsys_mem.cmo \
	   netsys_signal.cmo netsys_crypto_types.cmo netsys_crypto.cmo \
	   netsys_crypto_modes.cmo \
	   netsys_posix.cmo netsys_win32.cmo netsys_tls.cmo netsys.cmo \
	   netsys_ciphers.cmo netsys_digests.cmo netsys_rng.cmo \
	   netsys_pollset.cmo netsys_pollset_posix.cmo \
	   netsys_pollset_win32.cmo netsys_pollset_generic.cmo \
	   netsys_xdr.cmo netsys_tmp.cmo \
	   netsys_sem.cmo netsys_pmanage.cmo netsys_global.cmo \
	   netsys_gssapi.cmo netsys_sasl_types.cmo netsys_sasl_util.cmo \
	   netsys_sasl.cmo netsys_polypipe.cmo netsys_polysocket.cmo
COBJECTS = netsys_c.o netsys_c_poll.o netsys_c_fadvise.o \
	   netsys_c_fallocate.o netsys_c_ioprio.o netsys_c_locale.o \
           netsys_c_multicast.o netsys_c_sem.o netsys_c_shm.o \
           netsys_c_spawn.o netsys_c_subprocess.o netsys_c_syslog.o \
	   netsys_c_clock.o netsys_c_event.o \
           netsys_c_win32.o netsys_c_htab.o netsys_c_queue.o \
           netsys_c_mem.o netsys_c_xdr.o netsys_c_ip6.o
DOBJECTS = netsys.mli netsys_posix.mli netsys_pollset.mli netlog.mli \
           netexn.mli netsys_win32.mli netsys_pollset_posix.mli \
           netsys_pollset_win32.mli netsys_pollset_generic.mli \
           netsys_signal.mli netsys_oothr.mli netsys_xdr.mli \
	   netsys_rng.mli netsys_crypto_types.mli \
	   netsys_types.mli netsys_mem.mli netsys_tmp.mli \
	   netsys_sem.mli netsys_pmanage.mli netsys_crypto.mli netsys_tls.mli \
	   netsys_ciphers.mli netsys_digests.mli netsys_crypto_modes.mli \
	   netsys_gssapi.mli netsys_sasl_types.mli netsys_sasl.mli \
	   netsys_polypipe.mli netsys_polysocket.mli netsys_global.mli
LINK_OPTIONS = $(NETSYS_LINK_OPTIONS)

ALL_EXTRA = netsys_oothr.cma $(OOH_OBJECT)
ALLMT_EXTRA = netsys_oothr_mt.cma netsys_oothr_mt_init.cmo
OPT_EXTRA = netsys_oothr.cmxa netsys_c_gprof.o $(OOH_OBJECT)
OPTP_EXTRA = netsys_oothr.p.cmxa netsys_gprof_init.cmx
OPTMT_EXTRA = netsys_oothr_mt.cmxa netsys_oothr_mt_init.cmx
OPTMTP_EXTRA = netsys_oothr_mt.p.cmxa netsys_oothr_mt_init.cmx
# Note: we cannot refer here to *.p.cmx because there is no direct
# rule to build these files from .ml. They are implicitly built
# when the corresponding *.cmx (without .p) is created.

OCAMLC_OPTIONS_FOR_netsys_oothr_mt.mli = $(THREAD)
OCAMLC_OPTIONS_FOR_netsys_oothr_mt.ml = $(THREAD)
OCAMLC_OPTIONS_FOR_netsys_oothr_mt_init.mli = $(THREAD)
OCAMLC_OPTIONS_FOR_netsys_oothr_mt_init.ml = $(THREAD)
OCAMLOPT_OPTIONS_FOR_netsys_oothr_mt.ml = $(THREAD)
OCAMLOPT_OPTIONS_FOR_netsys_oothr_mt_init.ml = $(THREAD)
OCAMLC_OPTIONS_FOR_netsys_c_xdr.c = -ccopt -O

OCAMLC_OPTIONS += $(STRING_OPTS)
OCAMLOPT_OPTIONS += $(STRING_OPTS)

PP_OPTIONS = -pp "$(CPPO) $(DEF_O_SHARE_DELETE) $(DEF_O_CLOEXEC) $(PP_BYTES) $(PP_DEPRECATED)"

INSTALL_EXTRA += netsys_c_event.h $(OOH_OBJECT)

include $(TOP_DIR)/Makefile.rules

netsys_types.ml: netsys_types.mli
	echo '(* WARNING! THIS IS A COPY OF NETSYS_TYPES.MLI! *)' \
	    >netsys_types.ml
	cat netsys_types.mli >> netsys_types.ml

netsys_types.cmo: netsys_types.cmi
netsys_types.cmx: netsys_types.cmi

CLEAN_LIST += netsys_types.ml

.PHONY: cobjects
cobjects: $(COBJECTS)

netsys_oothr.cma: netsys_oothr.cmo
	$(OCAMLC) -o netsys_oothr.cma -a netsys_oothr.cmo

netsys_oothr.cmxa: netsys_oothr.cmx
	$(OCAMLOPT) -o netsys_oothr.cmxa -a netsys_oothr.cmx

netsys_oothr.p.cmxa: netsys_oothr.cmx
	$(OCAMLOPT) -o netsys_oothr.p.cmxa -a netsys_oothr.p.cmx

netsys_oothr_mt.cma: netsys_oothr.cmo netsys_oothr_mt.cmo
	$(OCAMLC) -o netsys_oothr_mt.cma -a \
		netsys_oothr.cmo netsys_oothr_mt.cmo

netsys_oothr_mt.cmxa: netsys_oothr.cmx netsys_oothr-$(MT_TYPE)
	$(OCAMLOPT) -o netsys_oothr_mt.cmxa -a \
		netsys_oothr.cmx netsys_oothr_mt.cmx

netsys_oothr_mt.p.cmxa: netsys_oothr.cmx netsys_oothr-$(MT_TYPE)
	$(OCAMLOPT) -o netsys_oothr_mt.p.cmxa -a \
		netsys_oothr.p.cmx netsys_oothr_mt.p.cmx

.PHONY: netsys_oothr-vm netsys_oothr-posix
netsys_oothr-vm:

netsys_oothr-posix: netsys_oothr_mt.cmx


clean::
	rm -f configtests/*.o configtests/*.err
	rm -f configtests/posix_shm

include depend

=== src/netunidata/Makefile ===
TOP_DIR=../..

include $(TOP_DIR)/Makefile.conf

PKGNAME  = netunidata
OBJECTS  = netuniconfig.cmo netunidata.cmo netunichecksums.cmo
DOBJECTS = netunidata.mli

INCLUDES += $(INC_NETSTRING)

MAPPINGS = netmappings_iso.ml \
	   netmappings_other.ml \
	   netmappings_jp.ml \
	   netmappings_kr.ml

ALL_EXTRA = $(MAPPINGS:.ml=.cmo) netuniinit.cmo
OPT_EXTRA = $(MAPPINGS:.ml=.cmx) netuniinit.cmx

OCAMLC_OPTIONS += $(STRING_OPTS)
OCAMLOPT_OPTIONS += $(STRING_OPTS)

PP_OPTIONS = -pp "$(CPPO) $(PP_BYTES) $(PP_DEPRECATED)"

include $(TOP_DIR)/Makefile.rules

include depend

=== src/netzip/Makefile ===
TOP_DIR=../..

include $(TOP_DIR)/Makefile.conf

PKGNAME = netzip
OBJECTS =  netgzip.cmo
DOBJECTS = netgzip.mli

INCLUDES = $(INC_NETSTRING)

# -safe-string is intentionally not enabled. At the time of trying this,
# camlzip was not yet ported to bytes.

#OCAMLC_OPTIONS += $(STRING_OPTS)
#OCAMLOPT_OPTIONS += $(STRING_OPTS)

PP_OPTIONS = -pp "$(CPPO) $(PP_BYTES) $(PP_DEPRECATED)"

REQUIRES += $(ZIP_PROVIDER)

DOC_IGNORABLE = true

include $(TOP_DIR)/Makefile.rules

include depend

=== src/rpc-xti/Makefile ===
TOP_DIR=../..

include $(TOP_DIR)/Makefile.conf

PKGNAME  = rpc-xti
ARCHIVE  = rpc_xti
OBJECTS  = rpc_xti_client.cmo
COBJECTS = rpcxti.o
DOBJECTS = rpc_xti_client.mli

INCLUDES += $(INC_RPC)

OCAMLC_OPTIONS += $(STRING_OPTS)
OCAMLOPT_OPTIONS += $(STRING_OPTS)

PP_OPTIONS = -pp "$(CPPO) $(PP_BYTES) $(PP_DEPRECATED)"

DOC_IGNORABLE = true

include $(TOP_DIR)/Makefile.rules

include depend

=== tools/cppo-0.9.4/Makefile ===
VERSION = 0.9.4

ifeq "$(shell ocamlc -config |grep os_type)" "os_type: Win32"
EXE=.exe
else
EXE=
endif

ifndef OCAMLYACC
  OCAMLYACC = ocamlyacc
  #OCAMLYACC = menhir
endif
export OCAMLYACC

ifndef PREFIX
  PREFIX = /usr/local
endif
export PREFIX

ifndef BINDIR
  BINDIR = $(PREFIX)/bin
endif
export BINDIR



BEST := opt
NATDYNLINK ?= $(shell if [ -f `ocamlc -where`/dynlink.cmxa ]; then \
                        echo YES; \
                      else \
                        echo NO; \
                      fi)

OCAMLBUILD_IMPL := ocamlbuild_cppo.cma

ifeq "${BEST}" "opt"
OCAMLBUILD_IMPL += ocamlbuild_cppo.cmxa ocamlbuild_cppo.a
ifeq "${NATDYNLINK}" "YES"
OCAMLBUILD_IMPL += ocamlbuild_cppo.cmxs
endif
endif

OCAMLBUILD_INSTALL = ocamlbuild_plugin/_build/ocamlbuild_cppo.cmi \
                     $(addprefix ocamlbuild_plugin/_build/,$(OCAMLBUILD_IMPL))


.PHONY: default all opt install clean test

default: opt ocamlbuild

ML = cppo_version.ml cppo_types.ml \
     cppo_parser.mli cppo_parser.ml \
     cppo_lexer.ml \
     cppo_command.ml \
     cppo_eval.ml cppo_main.ml

OCAMLBUILD_ML = ocamlbuild_cppo.ml

all: $(ML)
	ocamlc -o cppo$(EXE) -dtypes unix.cma $(ML)
	cp cppo$(EXE) cppo-ocamlnet$(EXE)

opt: $(ML)
	ocamlopt -o cppo$(EXE) -dtypes unix.cmxa $(ML)

ocamlbuild:
	cd ocamlbuild_plugin && ocamlbuild -use-ocamlfind $(OCAMLBUILD_IMPL)

install: install-bin install-lib

install-bin:
	install -m 0755 cppo $(BINDIR) || \
		install -m 0755 cppo.exe $(BINDIR)

install-lib:
	ocamlfind install -patch-version ${VERSION} "cppo_ocamlbuild" \
		META $(OCAMLBUILD_INSTALL)

cppo_version.ml: Makefile
	echo 'let cppo_version = "$(VERSION)"' > cppo_version.ml


cppo_lexer.ml: cppo_lexer.mll cppo_types.ml cppo_parser.ml
	ocamllex cppo_lexer.mll


ifeq ($(DEV),true)
cppo_parser.mli cppo_parser.ml: cppo_parser.mly cppo_types.ml
	menhir -v cppo_parser.mly
else
cppo_parser.mli cppo_parser.ml: cppo_parser.mly cppo_types.ml
	$(OCAMLYACC) cppo_parser.mly
endif

test:
	cd testdata; $(MAKE)

clean:
	rm -f *.cm[iox] *.o *.annot *.conflicts *.automaton \
		cppo \
		cppo_parser.mli cppo_parser.ml cppo_lexer.ml cppo_version.ml
	cd examples; $(MAKE) clean
	cd ocamlbuild_plugin; ocamlbuild -clean

=== examples/rpc/sort/Makefile ===
TOP_DIR = ../../..
include $(TOP_DIR)/Makefile.rules
include $(TOP_DIR)/Makefile.xrules

XDRFILES = sort1_proto.x sort2_proto.x

RPCGEN_AUX_OPTIONS    = -int unboxed -hyper int64
RPCGEN_CLIENT_OPTIONS = -int unboxed -hyper int64
RPCGEN_SERVER_OPTIONS = -int unboxed -hyper int64

CLEAN_LIST += *.astamp *.cstamp *.s2stamp *.run *.opt \
              sort1_proto_aux.ml  sort1_proto_aux.mli \
	      sort1_proto_clnt.ml sort1_proto_clnt.mli \
	      sort1_proto_srv.ml  sort1_proto_srv.mli \
              sort2_proto_aux.ml  sort2_proto_aux.mli \
	      sort2_proto_clnt.ml sort2_proto_clnt.mli \
	      sort2_proto_srv.ml  sort2_proto_srv.mli

all:
	$(MAKE) gen
	$(MAKE) depend
	$(MAKE) -f Makefile1.code all
	$(MAKE) -f Makefile2.code all

opt:
	$(MAKE) gen
	$(MAKE) depend
	$(MAKE) -f Makefile1.code opt
	$(MAKE) -f Makefile2.code opt

gen: $(XDRFILES:.x=.astamp) $(XDRFILES:.x=.cstamp) $(XDRFILES:.x=.s2stamp)

=== debian/changelog ===
ocamlnet (4.1.2-3) unstable; urgency=medium

  * Team upload.
  * Add patch from upstream to support Nettle 3.4+ (Closes: #887577)

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 27 Jan 2018 20:22:54 +0100

ocamlnet (4.1.2-2) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Import upstream patch to build with opaque files, instead of
    installing cmx files. Should fix approx FTBFS.
  * Revert previous patch. Building with opaque doesn't resolve
    approx FTBFS. Ship cmx files instead.

  [ Stéphane Glondu ]
  * Add support for O_KEEPEXEC (upstream fix for OCaml 4.05)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 20 Jul 2017 22:09:30 +0200

ocamlnet (4.1.2-1) unstable; urgency=medium

  * New upstream release
  * Update Vcs-*
  * Bump Standards-Version to 3.9.8

 -- Stéphane Glondu <glondu@debian.org>  Thu, 11 Aug 2016 12:32:33 +0200

=== debian/control ===
Source: ocamlnet
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper (>= 9),
 dh-ocaml (>= 0.9),
 dh-apache2,
 ocaml-nox (>= 4),
 camlp4,
 ocaml-findlib (>= 1.4),
 libfindlib-ocaml-dev,
 libpcre-ocaml-dev (>= 6.0.1-2~),
 liblablgtk2-ocaml-dev (>= 2.12.0-4~),
 libcryptgps-ocaml-dev (>= 0.2.1-7~),
 libzip-ocaml-dev,
 libgnutls28-dev,
 apache2-dev
Standards-Version: 3.9.8
Homepage: http://projects.camlcity.org/projects/ocamlnet.html
Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocamlnet.git
Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocamlnet.git

Package: libocamlnet-ocaml-dev
Architecture: any
Depends:
 ocaml-findlib,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 libocamlnet-ocaml-doc,
 libnethttpd-ocaml-dev
Provides:
 libequeue-ocaml-dev,
 libnetclient-ocaml-dev,
 librpc-ocaml-dev,
 ${ocaml:Provides}
Description: OCaml application-level Internet libraries - core development libraries
 Ocamlnet is a collection of OCaml libraries focusing focus on
 application-level Internet protocols and conventions.
 .
 Ocamlnet consists of the following libraries:
  * netstring: processing of strings that occur in network context
  * netcgi2: portable web applications
  * nethttpd: is a web server component (HTTP server implementation)
  * netplex: generic server framework
  * rpc: OncRPC implementation
  * netclient: clients for HTTP, FTP, and Telnet
  * equeue: event queue used for many protocol implementations
  * shell: external commands invocation
  * netshm: shared memory for IPC purposes
  * netsys: bindings for system functions
  * smtp and pop: two further client implementations
 .
 A number of ideas and concepts are used throughout the libraries:
  * netchannels are a way to abstract sequential I/O channels
  * event queues provided by equeue and unixqueue make asynchronous
    protocol interpreters possible
 .
 This package contains the development stuff you need to use the core
 Ocamlnet libraries in your programs. The following libraries are
 packaged separately: SSL-related libraries (libocamlnet-ssl-ocaml-dev),
 GTK-related libraries (libocamlnet-gtk2-ocaml-dev), nethttpd
 (libnethttpd-ocaml-dev). The netcgi2 Apache connector is also part of
 this package; to run applications built for that connector you will
 need the mod_netcgi_apache Apache module (libapache2-mod-ocamlnet).

Package: libocamlnet-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides:
 libequeue-ocaml,
 ${ocaml:Provides}
Description: OCaml application-level Internet libraries - core runtime libraries
 Ocamlnet is a collection of OCaml libraries focusing focus on
 application-level Internet protocols and conventions.
 .
 Ocamlnet consists of the following libraries:
  * netstring: processing of strings that occur in network context
  * netcgi2: portable web applications
  * nethttpd: is a web server component (HTTP server implementation)
  * netplex: generic server framework
  * rpc: OncRPC implementation
  * netclient: clients for HTTP, FTP, and Telnet
  * equeue: event queue used for many protocol implementations
  * shell: external commands invocation
  * netshm: shared memory for IPC purposes
  * netsys: bindings for system functions
  * smtp and pop: two further client implementations
 .
 A number of ideas and concepts are used throughout the libraries:
  * netchannels are a way to abstract sequential I/O channels
  * event queues provided by equeue and unixqueue make asynchronous
    protocol interpreters possible
 .
 This package contains only the shared runtime stub libraries for the
 core Ocamlnet libraries. Stub libraries for SSL-related components are
 available in the libocamlnet-ssl-ocaml-dev package.

Package: libocamlnet-ocaml-bin
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: libocamlnet-ocaml-dev
Description: OCaml application-level Internet libraries - binaries
 Ocamlnet is a collection of OCaml libraries focusing focus on
 application-level Internet protocols and conventions.
 .
 Ocamlnet consists of the following libraries:
  * netstring: processing of strings that occur in network context
  * netcgi2: portable web applications
  * nethttpd: is a web server component (HTTP server implementation)
  * netplex: generic server framework
  * rpc: OncRPC implementation
  * netclient: clients for HTTP, FTP, and Telnet
  * equeue: event queue used for many protocol implementations
  * shell: external commands invocation
  * netshm: shared memory for IPC purposes
  * netsys: bindings for system functions
  * smtp and pop: two further client implementations
 .
 A number of ideas and concepts are used throughout the libraries:
  * netchannels are a way to abstract sequential I/O channels
  * event queues provided by equeue and unixqueue make asynchronous
    protocol interpreters possible
 .
 This package contains the binaries ocamlrpcgen (a helper for creating
 RPC stubs) and netplex-admin (generic administration tool for netplex
 systems).

Package: libocamlnet-gtk2-ocaml-dev
Architecture: any
Depends:
 ocaml-findlib,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: libocamlnet-ocaml-doc
Provides:
 libequeue-gtk2-ocaml-dev,
 ${ocaml:Provides}
Description: OCaml application-level Internet libraries - GTK2 development libraries
 Ocamlnet is a collection of OCaml libraries focusing focus on
 application-level Internet protocols and conventions.
 .
 Ocamlnet consists of the following libraries:
  * netstring: processing of strings that occur in network context
  * netcgi2: portable web applications
  * nethttpd: is a web server component (HTTP server implementation)
  * netplex: generic server framework
  * rpc: OncRPC implementation
  * netclient: clients for HTTP, FTP, and Telnet
  * equeue: event queue used for many protocol implementations
  * shell: external commands invocation
  * netshm: shared memory for IPC purposes
  * netsys: bindings for system functions
  * smtp and pop: two further client implementations
 .
 A number of ideas and concepts are used throughout the libraries:
  * netchannels are a way to abstract sequential I/O channels
  * event queues provided by equeue and unixqueue make asynchronous
    protocol interpreters possible
 .
 This package contains the development stuff you need to use GTK-related
 libraries of Ocamlnet in your programs.

Package: libocamlnet-ssl-ocaml-dev
Architecture: any
Depends:
 ocaml-findlib,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: libocamlnet-ocaml-doc
Description: OCaml application-level Internet libraries - SSL development libraries
 Ocamlnet is a collection of OCaml libraries focusing focus on
 application-level Internet protocols and conventions.
 .
 Ocamlnet consists of the following libraries:
  * netstring: processing of strings that occur in network context
  * netcgi2: portable web applications
  * nethttpd: is a web server component (HTTP server implementation)
  * netplex: generic server framework
  * rpc: OncRPC implementation
  * netclient: clients for HTTP, FTP, and Telnet
  * equeue: event queue used for many protocol implementations
  * shell: external commands invocation
  * netshm: shared memory for IPC purposes
  * netsys: bindings for system functions
  * smtp and pop: two further client implementations
 .
 A number of ideas and concepts are used throughout the libraries:
  * netchannels are a way to abstract sequential I/O channels
  * event queues provided by equeue and unixqueue make asynchronous
    protocol interpreters possible
 .
 This package contains the development stuff you need to use SSL-related
 libraries of Ocamlnet in your programs.

Package: libocamlnet-ssl-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: OCaml application-level Internet libraries - SSL runtime libraries
 Ocamlnet is a collection of OCaml libraries focusing focus on
 application-level Internet protocols and conventions.
 .
 Ocamlnet consists of the following libraries:
  * netstring: processing of strings that occur in network context
  * netcgi2: portable web applications
  * nethttpd: is a web server component (HTTP server implementation)
  * netplex: generic server framework
  * rpc: OncRPC implementation
  * netclient: clients for HTTP, FTP, and Telnet
  * equeue: event queue used for many protocol implementations
  * shell: external commands invocation
  * netshm: shared memory for IPC purposes
  * netsys: bindings for system functions
  * smtp and pop: two further client implementations
 .
 A number of ideas and concepts are used throughout the libraries:
  * netchannels are a way to abstract sequential I/O channels
  * event queues provided by equeue and unixqueue make asynchronous
    protocol interpreters possible
 .
 This package contains only the shared runtime stub libraries for the
 SSL-related libraries of Ocamlnet.

Package: libnethttpd-ocaml-dev
Architecture: any
Depends:
 ocaml-findlib,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: libocamlnet-ocaml-doc
Description: OCaml application-level Internet libraries - HTTP daemon development libraries
 Ocamlnet is a collection of OCaml libraries focusing focus on
 application-level Internet protocols and conventions.
 .
 Ocamlnet consists of the following libraries:
  * netstring: processing of strings that occur in network context
  * netcgi2: portable web applications
  * nethttpd: is a web server component (HTTP server implementation)
  * netplex: generic server framework
  * rpc: OncRPC implementation
  * netclient: clients for HTTP, FTP, and Telnet
  * equeue: event queue used for many protocol implementations
  * shell: external commands invocation
  * netshm: shared memory for IPC purposes
  * netsys: bindings for system functions
  * smtp and pop: two further client implementations
 .
 A number of ideas and concepts are used throughout the libraries:
  * netchannels are a way to abstract sequential I/O channels
  * event queues provided by equeue and unixqueue make asynchronous
    protocol interpreters possible
 .
 This package contains the development stuff you need to use the
 nethttpd library in your programs.

Package: libapache2-mod-netcgi-apache
Architecture: any
Section: httpd
Depends:
 libocamlnet-ocaml-dev (= ${binary:Version}),
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Breaks: libapache2-mod-ocamlnet (<< 3.6)
Replaces: libapache2-mod-ocamlnet (<< 3.6)
Provides: libapache2-mod-ocamlnet
# This package contains only an Apache module, dh_ocaml doesn't work on it!
Description: OCaml application-level Internet libraries - netcgi2 Apache2 connector
 Ocamlnet is a collection of OCaml libraries focusing focus on
 application-level Internet protocols and conventions.
 .
 Ocamlnet consists of the following libraries:
  * netstring: processing of strings that occur in network context
  * netcgi2: portable web applications
  * nethttpd: is a web server component (HTTP server implementation)
  * netplex: generic server framework
  * rpc: OncRPC implementation
  * netclient: clients for HTTP, FTP, and Telnet
  * equeue: event queue used for many protocol implementations
  * shell: external commands invocation
  * netshm: shared memory for IPC purposes
  * netsys: bindings for system functions
  * smtp and pop: two further client implementations
 .
 A number of ideas and concepts are used throughout the libraries:
  * netchannels are a way to abstract sequential I/O channels
  * event queues provided by equeue and unixqueue make asynchronous
    protocol interpreters possible
 .
 This package contains the mod_netcgi_apache Apache module. You will

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/ocaml/ocamlvars.mk

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

PKGNAME = libocamlnet-ocaml-dev
DESTDIR = $(CURDIR)/debian/tmp
export OCAMLFIND_DESTDIR = $(DESTDIR)$(OCAML_STDLIB_DIR)

BUILD_TARGET = all
ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
BUILD_TARGET += opt
endif

CFGFLAGS =
CFGFLAGS += -enable-gtk2
CFGFLAGS += -with-nethttpd -prefer-netcgi2
CFGFLAGS += -bindir /usr/bin -datadir /usr/share/ocamlnet
CFGFLAGS += -enable-apache -apache /usr/sbin/apache2 -apxs /usr/bin/apxs2
CFGFLAGS += -enable-pcre -enable-zip
CFGFLAGS += -enable-gnutls

%:
	dh $@ --with ocaml,apache2

.PHONY: override_dh_auto_configure
override_dh_auto_configure: Makefile.conf

Makefile.conf:
	./configure $(CFGFLAGS)
ifeq ($(DEB_HOST_ARCH_OS),linux)
# In some build environments (especially cowbuilder and Ubuntu
# autobuilders), many netsys autotests fail even though the feature is
# available (LP: #257524)
	@echo
	@echo "The following netsys features will be forced:"
	@if grep '#undef ' src/netsys/config.h; then \
	  sed -i 's/#undef /#define /' src/netsys/config.h; \
	else \
	  echo "none"; \
	fi
	@echo
endif

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE) $(BUILD_TARGET)

.PHONY: override_dh_auto_install
override_dh_auto_install:
	$(MAKE) install DESTDIR=$(DESTDIR)

.PHONY: override_dh_auto_clean
override_dh_auto_clean: Makefile.conf
	$(MAKE) distclean

.PHONY: override_dh_install
override_dh_install:
	dh_install --fail-missing -X.so.owner -Xmod_netcgi_apache.so

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress -X.ml

.PHONY: override_dh_installchangelogs
override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

opts=uversionmangle=s/&#48\x3b/0/ \
http://download.camlcity.org/download/ocamlnet-(.*)\.tar\.gz

## ocamlnet 4.1.6

=== examples/netplex/Makefile ===
TOP_DIR = ../..
include $(TOP_DIR)/Makefile.rules
include $(TOP_DIR)/Makefile.xrules

XDRFILES = operation.x

RPCGEN_AUX_OPTIONS    = -int int32 -hyper int64
RPCGEN_CLIENT_OPTIONS = -int int32 -hyper int64
RPCGEN_SERVER_OPTIONS = -int int32 -hyper int64

CLEAN_LIST += *.astamp *.cstamp *.s2stamp
CLEAN_LIST += $(XDRFILES:.x=_aux.ml) $(XDRFILES:.x=_aux.mli)
CLEAN_LIST += $(XDRFILES:.x=_clnt.ml) $(XDRFILES:.x=_clnt.mli)
CLEAN_LIST += $(XDRFILES:.x=_srv.ml) $(XDRFILES:.x=_srv.mli)
CLEAN_LIST += test_client helper_container

.PHONY: all opt gen

all:
	$(MAKE) gen
	$(MAKE) depend
	$(MAKE) -f Makefile.code all

opt:
	$(MAKE) gen
	$(MAKE) depend
	$(MAKE) -f Makefile.code opt

gen: $(XDRFILES:.x=.astamp) $(XDRFILES:.x=.cstamp) $(XDRFILES:.x=.s2stamp)

=== src/netplex/Makefile ===
TOP_DIR=../..

include $(TOP_DIR)/Makefile.conf

PKGNAME  = netplex
OBJECTS  = netplex_types.cmo \
	   netplex_ctrl_aux.cmo netplex_ctrl_clnt.cmo netplex_ctrl_srv.cmo \
           netplex_util.cmo netplex_encap.cmo netplex_internal.cmo \
	   netplex_cenv.cmo netplex_mp.cmo netplex_mt.cmo netplex_log.cmo \
           netplex_container.cmo netplex_sockserv.cmo netplex_workload.cmo \
	   netplex_kit.cmo netplex_sharedvar.cmo netplex_controller.cmo \
           netplex_config.cmo netplex_main.cmo rpc_netplex.cmo \
           netplex_semaphore.cmo netplex_mutex.cmo \
	   netplex_mbox.cmo
DOBJECTS = netplex_types.mli netplex_mp.mli netplex_mt.mli netplex_log.mli \
	   netplex_controller.mli netplex_container.mli \
	   netplex_sockserv.mli netplex_workload.mli netplex_main.mli \
	   netplex_config.mli netplex_kit.mli rpc_netplex.mli \
	   netplex_cenv.mli netplex_semaphore.mli netplex_sharedvar.mli \
	   netplex_mutex.mli netplex_encap.mli netplex_mbox.mli \
	   netplex_internal.mli \
	   netplex_intro.txt netplex_advanced.txt netplex_admin.txt

OCAMLC_OPTIONS += $(STRING_OPTS)
OCAMLOPT_OPTIONS += $(STRING_OPTS)

PP_OPTIONS = -pp "$(CPPO) $(PP_BYTES) $(PP_DEPRECATED)"

INCLUDES += $(INC_EQUEUE) $(INC_RPC) $(INC_NETSTRING) $(INC_NETSYS)

ALL_EXTRA = netplex-admin$(EXEC_SUFFIX) netplex-packlist 

PACKLIST = netplex-packlist

include $(TOP_DIR)/Makefile.rules

netplex-admin$(EXEC_SUFFIX): netplex.cma netplex_admin.cmo
	$(OCAMLC) -o netplex-admin -custom \
	        -package "bytes unix bigarray str" -linkpkg \
		netsys_oothr.cma netsys.cma netstring.cma equeue.cma \
		rpc.cma netplex.cma netplex_admin.cmo

netplex-packlist:
	echo $(BINDIR)/netplex-admin >netplex-packlist

include depend

=== examples/equeue/multi-threaded/Makefile ===
# make all: 		make program
# make clean: 		remove intermediate files

#----------------------------------------------------------------------
# specific rules for this package:

OBJECTS  = sample.cmo
NAME     = sample
REQUIRES = equeue,threads

all: $(OBJECTS)
	$(OCAMLC) -o sample sample.cmo -linkpkg -custom

#----------------------------------------------------------------------
# general rules:

DEBUG     =
OPTIONS   =
OCAMLC    = ocamlfind ocamlc $(DEBUG) $(OPTIONS) -thread -package "$(REQUIRES)"
OCAMLOPT  = ocamlfind ocamlopt $(OPTIONS) $(ROPTIONS) -thread -package "$(REQUIRES)"
OCAMLDEP  = ocamldep $(OPTIONS)
OCAMLFIND = ocamlfind


.PHONY: clean
clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa sample 

.PHONY: CLEAN
CLEAN: clean

.PHONY: distclean
distclean: clean
	rm -f *~ a.old a.new

.SUFFIXES: .cmo .cmi .cmx .ml .mli

.ml.cmx:
	$(OCAMLOPT) -c $<

.ml.cmo:
	$(OCAMLC) -c $<

.mli.cmi:
	$(OCAMLC) -c $<

=== examples/netclient/telnet_labltk/Makefile ===
#----------------------------------------------------------------------
# specific rules for this package:

SOURCES  = telnet.ml
OBJECTS  = $(SOURCES:.ml=.cmo)
XOBJECTS = $(OBJECTS:.cmo=.cmx)
ARCHIVE  = telnet.cma
XARCHIVE = $(ARCHIVE:.cma=.cmxa)
NAME     = telnet
REQUIRES = netclient, labltk, equeue-tcl

all: $(ARCHIVE)
	$(OCAMLC) -o telnet $(ARCHIVE) main.ml \
		-custom -linkpkg

$(ARCHIVE): $(OBJECTS)
	$(OCAMLC) -a -o $(ARCHIVE) $(OBJECTS)

$(XARCHIVE): $(XOBJECTS) 
	$(OCAMLOPT) -a -o $(XARCHIVE) $(XOBJECTS)

#----------------------------------------------------------------------
# general rules:

OPTIONS   =
OCAMLC    = ocamlfind ocamlc   -package "$(REQUIRES)" \
		$(DEBUG) $(OPTIONS) 
OCAMLOPT  = ocamlfind ocamlopt -package "$(REQUIRES)" \
		$(OPTIONS)
OCAMLDEP  = ocamldep $(OPTIONS)
OCAMLLEX  = ocamllex
OCAMLFIND = ocamlfind

DEBUG  =
# Invoke with: make DEBUG=-g

depend: $(SOURCES) 
	$(OCAMLDEP) *.ml >depend

.PHONY: clean
clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa telnet

.PHONY: distclean
distclean: clean
	rm -f *~ depend depend.pkg

.SUFFIXES: .cmo .cmi .cmx .ml .mli .mll

.ml.cmx:
	$(OCAMLOPT) -c $<

.ml.cmo:
	$(OCAMLC) -c $<

.mli.cmi:
	$(OCAMLC) -c $<

.mll.ml:
	$(OCAMLLEX) $<

*.mli:
	true

include depend

=== debian/changelog ===
ocamlnet (4.1.6-1build6) focal; urgency=medium

  * No-change rebuild against ocaml-nox-4.08.1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 21 Feb 2020 07:32:50 +0000

ocamlnet (4.1.6-1build5) focal; urgency=medium

  * No-change rebuild for new ocaml ABIs

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 01 Feb 2020 00:40:06 +0000

ocamlnet (4.1.6-1build4) focal; urgency=medium

  * No-change rebuild against libnettle7

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 31 Oct 2019 22:12:57 +0000

ocamlnet (4.1.6-1build3) eoan; urgency=medium

  * No-change upload with strops.h and sys/strops.h removed in glibc.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Sep 2019 11:04:36 +0000

ocamlnet (4.1.6-1build2) eoan; urgency=medium

  * No-change rebuild against libfindlib-ocaml-cfdg9

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 22 Aug 2019 06:55:49 +0000

ocamlnet (4.1.6-1build1) eoan; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 21 Aug 2019 15:13:28 +0200

ocamlnet (4.1.6-1) unstable; urgency=medium

  * New upstream release
  * Remove libcryptgps-ocaml-dev from Build-Depends
  * Bump Standards-Version to 4.4.0
  * Bump debhelper compat level to 12

 -- Stéphane Glondu <glondu@debian.org>  Mon, 12 Aug 2019 16:12:54 +0200

ocamlnet (4.1.2-4) unstable; urgency=high

  * Force rebuild of all packages on buildds
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Fri, 02 Aug 2019 10:17:53 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: ocamlnet
 Section: ocaml
 Priority: optional
-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
  Stéphane Glondu <glondu@debian.org>
 Build-Depends:
- debhelper (>= 9),
+ debhelper (>= 12),
  dh-ocaml (>= 0.9),
  dh-apache2,
  ocaml-nox (>= 4),
@@ -14,14 +15,13 @@
  libfindlib-ocaml-dev,
  libpcre-ocaml-dev (>= 6.0.1-2~),
  liblablgtk2-ocaml-dev (>= 2.12.0-4~),
- libcryptgps-ocaml-dev (>= 0.2.1-7~),
  libzip-ocaml-dev,
  libgnutls28-dev,
  apache2-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.4.0
 Homepage: http://projects.camlcity.org/projects/ocamlnet.html
-Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocamlnet.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocamlnet.git
+Vcs-Git: https://salsa.debian.org/ocaml-team/ocamlnet.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/ocamlnet
 
 Package: libocamlnet-ocaml-dev
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -56,9 +56,8 @@
 override_dh_auto_clean: Makefile.conf
 	$(MAKE) distclean
 
-.PHONY: override_dh_install
-override_dh_install:
-	dh_install --fail-missing -X.so.owner -Xmod_netcgi_apache.so
+override_dh_missing:
+	dh_missing --fail-missing -X.so.owner -Xmod_netcgi_apache.so
 
 .PHONY: override_dh_compress
 override_dh_compress:
